
#include <Misc.au3>

AutoItSetOption ("WinTitleMatchMode", 2)

#cs

alignment fixer for excel

This script creates keyboard shortcuts which interact with Excel to perform roughly the same functions as PlusTools.  The user must paste the segmented source text into column A and the segmented target text into column B.

One could also create little macros for Excel, and bind them to keyboard shortcuts, but then the user can't use "undo".

#ce

MsgBox (0, "Alignment Fixer for Excel", "Press Ctrl + ? for shortcuts.", 0)

$titlebartext = InputBox ("Unique portion of Excel title", "What is the unique portion of your Excel file's file name in the title bar?", "Excel")

$speed = InputBox ("Speed?", "Very large file? Try a higher number (e.g. 500 or 1000)", "1")

HotKeySet("^/", "showhelp")
HotKeySet("^?", "showhelp")
HotKeySet("^q", "exitty")
HotKeySet("^{ENTER}", "editcell")

HotKeySet("^m", "mergewithbelow")
HotKeySet("^+m", "mergewithinsert")

HotKeySet("^+s", "splitcells")
HotKeySet("^i", "insertcellhere")
HotKeySet("^d", "deletethiscell")

HotKeySet("^+i", "insertcellbelow")
; HotKeySet("^+d", "deletecellabove")

While 1
    Sleep (1)
WEnd

Func exitty ()
MsgBox (0, "Alignment Fixer for Excel", "Alignment Fixer will now exit", 5)
Exit
EndFunc

Func showhelp()
MsgBox (0, "Alignment Fixer for Excel", "Ctrl + ? = Help" & @CRLF & "Ctrl + Q = Exit" & @CRLF & @CRLF & "Ctrl + ENTER = Edit/exit cell" & @CRLF & "Ctrl + M = Merge" & @CRLF & "Ctrl + Shift + S = Split" & @CRLF & "Ctrl + I = Insert" & @CRLF & "Ctrl + D = Delete" & @CRLF & @CRLF & "Ctrl + Shift + M = Merge + insert" & @CRLF & "Ctrl + Shift + I = Insert below" & @CRLF & "Ctrl + Shift + D = Delete above", 0)
EndFunc

Func editcell ()
While _IsPressed ("A2") = 1
Wend
If WinActive ($titlebartext, "") Then
Send ("{F2}")
; Send ("^{HOME}") ; no, not until we can detect F2
EndIf
EndFunc

Func mergewithbelow ()
While _IsPressed ("A2") = 1
Wend
If WinActive ($titlebartext, "") Then
Send ("{DOWN}")
Send ("{F2}")
Send ("^{END}")
Send ("^+{HOME}")
Send ("^x")
Send ("{F2}")
Send ("{UP}")
Send ("{F2}")
Send ("^{END}")
Send (" ")
Send ("^v")
Send ("{F2}")
Send ("{DOWN}")
Send ("^-")
WinWaitActive ("Delete", "")
Send ("!u")
Send ("{ENTER}")
Sleep ($speed)
Send ("{UP}")
EndIf
EndFunc

Func mergewithinsert ()
While _IsPressed ("A2") = 1
Wend
While _IsPressed ("A0") = 1
Wend
If WinActive ($titlebartext, "") Then
Send ("{DOWN}")
Send ("{F2}")
Send ("^{END}")
Send ("^+{HOME}")
Send ("^x")
Send ("{F2}")
Send ("{UP}")
Send ("{F2}")
Send ("^{END}")
Send (" ")
Send ("^v")
Send ("{F2}")
EndIf
EndFunc

Func splitcells()
While _IsPressed ("A2") = 1
Wend
If WinActive ($titlebartext, "") Then
Send ("^+{END}")
Send ("^x")
Send ("{F2}")
Send ("{DOWN}")
Send ("^+=")
WinWaitActive ("Insert", "")
Send ("!d")
Send ("{ENTER}")
Sleep ($speed)
Send ("^v")
EndIf
EndFunc

Func insertcellhere()
While _IsPressed ("A2") = 1
Wend
If WinActive ($titlebartext, "") Then
Send ("^+=")
While _IsPressed ("A2") = 1
Wend
WinWaitActive ("Insert", "")
Send ("!d")
Send ("{ENTER}")
EndIf
EndFunc

Func deletethiscell()
While _IsPressed ("A2") = 1
Wend
If WinActive ($titlebartext, "") Then
Send ("^-")
While _IsPressed ("A2") = 1
Wend
WinWaitActive ("Delete", "")
Send ("!u")
Send ("{ENTER}")
Sleep ($speed)
Send ("{UP}")
Send ("{DOWN}")
EndIf
EndFunc

Func insertcellbelow()
While _IsPressed ("A2") = 1
Wend
While _IsPressed ("A0") = 1
Wend
If WinActive ($titlebartext, "") Then
Send ("{DOWN}")
Send ("^+=")
While _IsPressed ("A2") = 1
Wend
WinWaitActive ("Insert", "")
Send ("!d")
Send ("{ENTER}")
EndIf
EndFunc

Func deletecellabove ()
While _IsPressed ("A2") = 1
Wend
While _IsPressed ("A0") = 1
Wend
If WinActive ($titlebartext, "") Then
Send ("{UP}")
Send ("^-")
While _IsPressed ("A2") = 1
Wend
WinWaitActive ("Delete", "")
Send ("!u")
Send ("{ENTER}")
Sleep ($speed)
Send ("{UP}")
Send ("{DOWN}")
EndIf
EndFunc

